/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 193 by dpavlin, Fri Mar 19 14:11:49 2010 UTC revision 284 by dpavlin, Tue Dec 13 12:54:24 2011 UTC
# Line 37  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56  lxc_status() {  lxc_status() {
57          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58                  boot="    "                  status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2`     # 0.7.5
59                    test -z "$status" && status=`lxc-info -n $name | sed -e 's/^.* is //'` # 0.7.2
60                    boot="-"
61                  test -s /var/lib/lxc/$name/on_boot && boot="boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
62                  echo "$name $status $boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
63          done          done ) | column -t
64  }  }
65    
66    
# Line 54  cleanup_init_scripts() { Line 68  cleanup_init_scripts() {
68          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
69    
70          ls \          ls \
71                    $rootfs/etc/rc?.d/*checkroot* \
72                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
73                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
74                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
75                    $rootfs/etc/rc?.d/*udev* \
76                    $rootfs/etc/rc?.d/*checkfs* \
77          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
78    
79            echo $1 > $rootfs/etc/hostname
80            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
81  }  }
82    
83    
# Line 68  setup_inittab() { Line 88  setup_inittab() {
88    
89          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
90          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
91          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
92                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
93                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
94                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 86  lxc_kill() { Line 106  lxc_kill() {
106          name=$1          name=$1
107          sig=$2          sig=$2
108    
109          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`          ver=`lxc-version | cut -d: -f2 | sed 's/\.//g'`
110            opts=''
111            test $ver -ge 075 && opts='--'
112    
113            init_pid=`lxc-ps $opts -C init -o pid | grep "^$name" | cut -d" " -f2-`
114          if [ -z "$init_pid" ] ; then          if [ -z "$init_pid" ] ; then
115                  lxc-info -n $name                  lxc-info -n $name
116                  exit 1                  exit 1
# Line 106  lxc_stop() { Line 130  lxc_stop() {
130    
131  lxc_start() {  lxc_start() {
132          name=$1          name=$1
133            rootfs=$(lxc_rootfs $1)
134    
135            if [ ! -e $rootfs ] ; then
136                    echo "ERROR $name rootfs $rootfs not found"
137                    return
138            fi
139    
140          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
141                  lxc_log "$name start"                  lxc_log "$name start"
142                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
143                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
144                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
145                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
146                  lxc-info  -n $name                  lxc-info  -n $name
# Line 119  lxc_start() { Line 151  lxc_start() {
151  lxc_watchdog() {  lxc_watchdog() {
152  name=$1  name=$1
153  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
154    run=$rootfs/var/run
155    test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
156    cd $run || echo "can't cd watchdog into $run"
157    
158  while true; do  while true; do
         vps_utmp=${rootfs}/var/run/utmp  
159          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
160            stop_on=1 # init
161            sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
162            if [ "$sulogins" -gt 0 ] ; then
163                    stop_on=`expr $stop_on + $sulogins`
164            fi
165    
166          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
167          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
168    
169                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel utmp)"
170                  lxc_log "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
171    
172                  case $runlevel in                  case $runlevel in
173                  N*)                  N*)
174                          # nothing for new boot state                          # nothing for new boot state
175                  ;;                  ;;
176                  ??0)                  ??0|unknown)
177                          lxc_log "$name halt"                          lxc_log "$name halt"
178                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
179                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
# Line 152  while true; do Line 192  while true; do
192                  ;;                  ;;
193                  esac                  esac
194          else          else
195                  lxc_log "$name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
196          fi          fi
197    
198          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
199          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 utmp
200  done  done
201    
202  lxc_log "$name watchdog exited"  lxc_log "$name watchdog exited"

Legend:
Removed from v.193  
changed lines
  Added in v.284

  ViewVC Help
Powered by ViewVC 1.1.26